diff --git a/qapi/block-core.json b/qapi/block-core.json
index 1d3dd9cb48e..1846a91873a 100644
--- a/qapi/block-core.json
+++ b/qapi/block-core.json
@@ -1839,7 +1839,7 @@
 #
 # @id: Block graph node identifier. This @id is generated only for
 #      x-debug-query-block-graph and does not relate to any other identifiers in
-#      Qemu.
+#      QEMU.
 #
 # @type: Type of graph node. Can be one of block-backend, block-job or
 #        block-driver-state.
diff --git a/python/qemu/machine/machine.py b/python/qemu/machine/machine.py
index a487c397459..627c9013946 100644
--- a/python/qemu/machine/machine.py
+++ b/python/qemu/machine/machine.py
@@ -122,7 +122,7 @@ def __init__(self,
         @param console_log: (optional) path to console log file
         @param log_dir: where to create and keep log files
         @param qmp_timer: (optional) default QMP socket timeout
-        @note: Qemu process is not started until launch() is used.
+        @note: QEMU process is not started until launch() is used.
         '''
         # pylint: disable=too-many-arguments
 
diff --git a/scripts/checkpatch.pl b/scripts/checkpatch.pl
index cb8eff233e0..aedf9beaed0 100755
--- a/scripts/checkpatch.pl
+++ b/scripts/checkpatch.pl
@@ -2910,7 +2910,7 @@ sub process {
 			ERROR("use QEMU instead of Qemu or QEmu\n" . $herecurr);
 		}
 
-# Qemu error function tests
+# QEMU error function tests
 
 	# Find newlines in error messages
 	my $qemu_error_funcs = qr{error_setg|
diff --git a/scripts/render_block_graph.py b/scripts/render_block_graph.py
index da6acf050d1..3147b0b843b 100755
--- a/scripts/render_block_graph.py
+++ b/scripts/render_block_graph.py
@@ -1,6 +1,6 @@
 #!/usr/bin/env python3
 #
-# Render Qemu Block Graph
+# Render QEMU Block Graph
 #
 # Copyright (c) 2018 Virtuozzo International GmbH. All rights reserved.
 #
diff --git a/scripts/simplebench/bench-backup.py b/scripts/simplebench/bench-backup.py
index 5a0675c593c..ad37af3e719 100755
--- a/scripts/simplebench/bench-backup.py
+++ b/scripts/simplebench/bench-backup.py
@@ -183,7 +183,7 @@ def __call__(self, parser, namespace, values, option_string=None):
     mirror               use mirror job instead of backup''',
                                 formatter_class=argparse.RawTextHelpFormatter)
     p.add_argument('--env', nargs='+', help='''\
-Qemu binaries with labels and options, see below
+QEMU binaries with labels and options, see below
 "ENV format" section''',
                    action=ExtendAction)
     p.add_argument('--dir', nargs='+', help='''\
@@ -209,7 +209,7 @@ def __call__(self, parser, namespace, values, option_string=None):
     p.add_argument('--target-cache', help='''\
 Setup cache for target nodes. Options:
    direct: default, use O_DIRECT and aio=native
-   cached: use system cache (Qemu default) and aio=threads (Qemu default)
+   cached: use system cache (QEMU default) and aio=threads (QEMU default)
    both: generate two test cases for each src:dst pair''',
                    default='direct', choices=('direct', 'cached', 'both'))
 
diff --git a/scripts/simplebench/bench_block_job.py b/scripts/simplebench/bench_block_job.py
index a403c35b08f..ecbcd535bcb 100755
--- a/scripts/simplebench/bench_block_job.py
+++ b/scripts/simplebench/bench_block_job.py
@@ -36,7 +36,7 @@ def bench_block_job(cmd, cmd_args, qemu_args):
 
     cmd       -- qmp command to run block-job (like blockdev-backup)
     cmd_args  -- dict of qmp command arguments
-    qemu_args -- list of Qemu command line arguments, including path to Qemu
+    qemu_args -- list of QEMU command line arguments, including path to QEMU
                  binary
 
     Returns {'seconds': int} on success and {'error': str} on failure, dict may
diff --git a/target/hexagon/README b/target/hexagon/README
index 372e24747c9..b02dbbd1701 100644
--- a/target/hexagon/README
+++ b/target/hexagon/README
@@ -48,7 +48,7 @@ header files in <BUILD_DIR>/target/hexagon
         gen_tcg_func_table.py           -> tcg_func_table_generated.c.inc
         gen_helper_funcs.py             -> helper_funcs_generated.c.inc
 
-Qemu helper functions have 3 parts
+QEMU helper functions have 3 parts
     DEF_HELPER declaration indicates the signature of the helper
     gen_helper_<NAME> will generate a TCG call to the helper function
     The helper implementation
diff --git a/tests/guest-debug/run-test.py b/tests/guest-debug/run-test.py
index 2e58795a100..268a230ecc3 100755
--- a/tests/guest-debug/run-test.py
+++ b/tests/guest-debug/run-test.py
@@ -21,9 +21,9 @@
 
 def get_args():
     parser = argparse.ArgumentParser(description="A gdbstub test runner")
-    parser.add_argument("--qemu", help="Qemu binary for test",
+    parser.add_argument("--qemu", help="QEMU binary for test",
                         required=True)
-    parser.add_argument("--qargs", help="Qemu arguments for test")
+    parser.add_argument("--qargs", help="QEMU arguments for test")
     parser.add_argument("--binary", help="Binary to debug",
                         required=True)
     parser.add_argument("--test", help="GDB test script",
diff --git a/tests/qemu-iotests/testenv.py b/tests/qemu-iotests/testenv.py
index c33454fa685..b563b6d5e6d 100644
--- a/tests/qemu-iotests/testenv.py
+++ b/tests/qemu-iotests/testenv.py
@@ -157,7 +157,7 @@ def root(*names: str) -> str:
                 progs = sorted(glob.iglob(pattern))
                 self.qemu_prog = next(p for p in progs if isxfile(p))
             except StopIteration:
-                sys.exit("Not found any Qemu executable binary by pattern "
+                sys.exit("Not found any QEMU executable binary by pattern "
                          f"'{pattern}'")
 
         self.qemu_img_prog = os.getenv('QEMU_IMG_PROG', root('qemu-img'))